freeslot("MT_HYPERSONICSPARKLE", "S_HYPERSONICSPARKLE1", "S_HYPERSONICSPARKLE2", "S_HYPERSONICSPARKLE3", "SPR_SPKL")

mobjinfo[MT_HYPERSONICSPARKLE] = {
	doomednum = -1,
	spawnstate = S_HYPERSONICSPARKLE1,
	deathstate = S_NULL,
	health = 99999,
    radius = 12*FRACUNIT,
    height = 8*FRACUNIT,
	flags = MF_NOCLIP|MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_NOCLIPTHING
}

states[S_HYPERSONICSPARKLE1] = {
	sprite = SPKL,
	frame = C,
	tics = -1,
	nextstate = S_NULL,
	var1 = 0,
	var2 = 0
}

freeslot("MT_SONICDUMMY", "S_SONICDUMMY", "SPR_DEDS")

mobjinfo[MT_SONICDUMMY] = {
	doomednum = -1,
	spawnstate = S_HYPERSONICSPARKLE1,
	deathstate = S_NULL,
	health = 99999,
    radius = 12*FRACUNIT,
    height = 8*FRACUNIT
}

states[S_SONICDUMMY] = {
	sprite = DEDS,
	frame = C,
	tics = -1,
	nextstate = S_NULL,
	var1 = 0,
	var2 = 0,
	flags = MF_NOGRAVITY
}

freeslot("sfx_hyprw1", "sfx_hyprw2", "sfx_hyprw3")

local hypersonic = {}

local function Sparkle(mo, momx, momy, momz, offset, frame, color)
	local sparkle = P_SpawnMobj(mo.x, mo.y, mo.z, MT_HYPERSONICSPARKLE) 
	if offset then
		P_SetOrigin(sparkle, P_RandomRange(-10, 10) * FRACUNIT + mo.x, P_RandomRange(-10, 10) * FRACUNIT + mo.y, 20*FRACUNIT + mo.z)
	end
	sparkle.momx = momx
	sparkle.momy = momy
	sparkle.momz =  momz
	sparkle.colorized = true
	sparkle.color = color
	sparkle.fuse = 10
	sparkle.scale = mo.scale*2/3
	sparkle.source = mo
	sparkle.offset = offset
	if frame then
		sparkle.sprite = SPR_SPKL
		sparkle.frame = frame
		sparkle.animation = true
		sparkle.scale = $*2
	end
end

local function ExplosionSparkle(mo, momx, momy, momz, offset, frame, color)
	local sparkle = P_SpawnMobj(mo.x, mo.y, mo.z, MT_HYPERSONICSPARKLE) 
	if offset then
		P_SetOrigin(sparkle, P_RandomRange(-10, 10) * FRACUNIT + mo.x, P_RandomRange(-10, 10) * FRACUNIT + mo.y, 20*FRACUNIT + mo.z)
	end
	sparkle.momx = momx
	sparkle.momy = momy
	sparkle.momz =  momz
	sparkle.colorized = true
	sparkle.color = color
	sparkle.fuse = 35
	sparkle.scale = mo.scale*2/3
	sparkle.source = mo
	sparkle.offset = offset
	if frame then
		sparkle.sprite = SPR_SPKL
		sparkle.frame = frame
		sparkle.animation = true
		sparkle.scale = $*3
	end
	sparkle.explosion = true
end

local function SparkleRing(mo, color)
	//player.cmd.angleturn*FRACUNIT
	//mo.angle = 0
	--Let's do the easy ones first
	Sparkle(mo, 0, 0, 9*FRACUNIT, false, C, color)
	Sparkle(mo, 0, 0, -9*FRACUNIT, false, C, color)
	
	--Then the slightly less easy ones
	Sparkle(mo, 9*cos(mo.angle+ANGLE_90), 9*sin(mo.angle+ANGLE_90), 0, false, C, color)
	Sparkle(mo, -9*cos(mo.angle+ANGLE_90), -9*sin(mo.angle+ANGLE_90), 0, false, C, color)
	
	--Then the harder-than-those ones
	Sparkle(mo, FixedMul(9*cos(mo.angle+ANGLE_90),cos(ANGLE_45)), FixedMul(9*sin(mo.angle+ANGLE_90),cos(ANGLE_45)), 9*sin(ANGLE_45), false, C, color)
	Sparkle(mo, FixedMul(9*cos(mo.angle+ANGLE_90),-cos(ANGLE_45)), FixedMul(9*sin(mo.angle+ANGLE_90),-cos(ANGLE_45)), 9*sin(ANGLE_45), false, C, color)
	Sparkle(mo, FixedMul(9*cos(mo.angle+ANGLE_90),cos(ANGLE_45)), FixedMul(9*sin(mo.angle+ANGLE_90),cos(ANGLE_45)), 9*-sin(ANGLE_45), false, C, color)
	Sparkle(mo, FixedMul(9*cos(mo.angle+ANGLE_90),-cos(ANGLE_45)), FixedMul(9*sin(mo.angle+ANGLE_90),-cos(ANGLE_45)), 9*-sin(ANGLE_45), false, C, color)
end

local function ExplosionSparkleRing(mo, angle, color)
	//player.cmd.angleturn*FRACUNIT
	//mo.angle = 0
	--Let's do the easy ones first
	ExplosionSparkle(mo, 0, 0, 9*FRACUNIT, false, C, color)
	ExplosionSparkle(mo, 0, 0, -9*FRACUNIT, false, C, color)
	
	--Then the slightly less easy ones
	ExplosionSparkle(mo, 9*cos(angle+ANGLE_90), 9*sin(angle+ANGLE_90), 0, false, C, color)
	ExplosionSparkle(mo, -9*cos(angle+ANGLE_90), -9*sin(angle+ANGLE_90), 0, false, C, color)
	
	--Then the harder-than-those ones
	ExplosionSparkle(mo, FixedMul(9*cos(angle+ANGLE_90),cos(ANGLE_45)), FixedMul(9*sin(angle+ANGLE_90),cos(ANGLE_45)), 9*sin(ANGLE_45), false, C, color)
	ExplosionSparkle(mo, FixedMul(9*cos(angle+ANGLE_90),-cos(ANGLE_45)), FixedMul(9*sin(angle+ANGLE_90),-cos(ANGLE_45)), 9*sin(ANGLE_45), false, C, color)
	ExplosionSparkle(mo, FixedMul(9*cos(angle+ANGLE_90),cos(ANGLE_45)), FixedMul(9*sin(angle+ANGLE_90),cos(ANGLE_45)), 9*-sin(ANGLE_45), false, C, color)
	ExplosionSparkle(mo, FixedMul(9*cos(angle+ANGLE_90),-cos(ANGLE_45)), FixedMul(9*sin(angle+ANGLE_90),-cos(ANGLE_45)), 9*-sin(ANGLE_45), false, C, color)
end

local function SparkleExplosion(mo, color)
	local angle = mo.angle
	
	for i = 1, 8 do
		ExplosionSparkleRing(mo, angle, color)
		angle = $+ANGLE_45
	end
end

local function BoolToNumber(bool)
	if bool then
		return 1
	else
		return 0
	end
end

local function OverwriteLocalData(mo)
	if mo.player == nil then return end
	if not (player.mo.skin == "hypersonic" and player.mo and player.mo.valid and player.mo.health) then return end
	if not player.hypersonic then return end
	
	local default = "00"
	
	local values = {}
	values[0] = BoolToNumber(player.hypersonic.hyperflashing)
	
	local file = io.open("hypersonic.cfg", "w+")
end

local function PrintHyperMessage(var)
	if not var then return end
	if leveltime == 0 then
		if var.name == "hyper_health" then
			if var.value == 0 then
				if G_BattleGametype() then
					print("This battle, \130Hyper Sonic \128will have \130infinite \128health.")
				elseif G_RaceGametype() then
					print("This race, \130Hyper Sonic \128will have \130infinite \128health.")
				else
					print("This match, \130Hyper Sonic \128will have \130infinite \128health.")
				end
			else
				if G_BattleGametype() then
					print("This battle, \130Hyper Sonic \128will start with \130" + var.value*3 + " \128health.")
				elseif G_RaceGametype() then
					print("This race, \130Hyper Sonic \128will start with \130" + var.value + " \128health.")
				else
					print("This match, \130Hyper Sonic \128will start with \130" + var.value + " \128health.")
				end
			end
		end
	else
		if var.name == "hyper_health" then
			print("Starting next match, \130Hyper Sonic \128will start with \130" + var.value + " \128health.")
		end
	end
end

local function HUDShake(mo, value)
	mo.player.hypersonic.hudshakex = 0
	mo.player.hypersonic.hudshakey = 0
	
	for i = 1, FixedCeil(value)/FRACUNIT do
		if i == FixedCeil(value)/FRACUNIT then
			mo.player.hypersonic.hudshakex = $+P_RandomKey(FixedCeil(value) - value)
			mo.player.hypersonic.hudshakey = $+P_RandomKey(FixedCeil(value) - value)
		else
			mo.player.hypersonic.hudshakex = $+P_RandomFixed()
			mo.player.hypersonic.hudshakey = $+P_RandomFixed()
		end
	end
	
	if P_RandomChance(FRACUNIT/2) then
		mo.player.hypersonic.hudshakex = $*-1
	end
	if P_RandomChance(FRACUNIT/2) then
		mo.player.hypersonic.hudshakey = $*-1
	end
end

local function DisplayPlayerIndex(player)
	local dps = 0
	for dp in displayplayers.iterate() do
		dps = $+1
	end
	player.hypersonic.totaldisplays = dps
end

local function MapLoadHook(player)
	if player == nil then return end
	if player.mo.skin == "hypersonic" and player.mo and player.mo.valid and player.mo.health then
		player.hypersonic = {}
		player.hypersonic.driftboosting = false
		player.hypersonic.lastboosttimer = 0
		player.hypersonic.lastdrifttimer = 0
		player.hypersonic.lastdriftboost = 0
		player.hypersonic.timesincelastring = 35
		player.hypersonic.bounceinvuln = 0
		player.hypersonic.washit = 0
		player.hypersonic.waslow = false
		player.hypersonic.isdead = false
		player.hypersonic.framesdead = 0
		player.hypersonic.canplay = 2
		player.hypersonic.startedhyper = true
		player.hypersonic.islastplayer = false
		HUDShake(player.mo, 0)
		DisplayPlayerIndex(player)
		if player.hypersonic.originalcolor == nil then
			player.hypersonic.originalcolor = player.skincolor
		end

		local number = 0
		for p in players.iterate do
			if p.mo then number = $+1 end
		end

		--Disables health if more than one player is in the game (also disables it in battle mode)
		if CV_FindVar("hyper_health").value == 0 or number > 1 or not G_RaceGametype() then
			player.hypersonic.health = -FRACUNIT
			player.hypersonic.usinghealth = false
		else
			--Just in case I wanted to scale it based on lap count
			--It didn't work on Grand Metropolis, so I scrapped that
			if G_BattleGametype() then
				player.hypersonic.health = CV_FindVar("hyper_health").value
			elseif G_RaceGametype()
				player.hypersonic.health = CV_FindVar("hyper_health").value
			else
				player.hypersonic.health = CV_FindVar("hyper_health").value
			end
			player.hypersonic.usinghealth = true
		end
	elseif player.mo.skin != "hypersonic" then
	
	end
end

rawset(_G, "hyper_health", CV_RegisterVar({
  name = "hyper_health",
  defaultvalue = 150,
  flags = CV_NETVAR|CV_CALL,
  PossibleValue = CV_Unsigned,
  func = PrintHyperMessage
}))

addHook("MapLoad", function()
	for player in players.iterate do
		MapLoadHook(player)
	end
end)

addHook("PlayerCmd", function(player, cmd)
	if not (player.mo.skin == "hypersonic" and player.mo and player.mo.valid and player.mo.health) then return end
	if not player.hypersonic then return end
	
	if player.hypersonic.isdead then
		cmd.buttons = 0
		cmd.forwardmove = 0
		cmd.sidemove = 0
	end
end)

addHook("ThinkFrame", do
	for player in players.iterate do
		if leveltime == 0 then
			MapLoadHook(player)
		end
		
		if not (player.mo and player.mo.valid) then continue end
		if not player.mo.skin == "hypersonic" then continue end
		if not player.hypersonic then continue end
		if player.exiting > 0 then continue end //would you really want to lose after you just won
		
		for i = 0,108 do
		  S_StopSoundByID(player.mo, sfx_krta00 + i)
		end

		if player.hypersonic.isdead then
			if G_BattleGametype() then
				player.kartstuff[k_comebackmode] = -1
				player.kartstuff[k_comebacktimer] = -1
				hud.disable("battlecomebacktimer")
				//hud.disable("gametypeinfo")
				hud.disable("battlefullscreen")
			end

			if player.hypersonic.framesdead >= 3*TICRATE and player.hypersonic.islastplayer then
				G_ExitLevel()
			end
			if player.hypersonic.framesdead == 0 then
				player.pflags = $|PF_TIMEOVER
				player.lives = 0
				
				local finished = false
				local stillpinch = false
				local playercount = 0
				local pinchhypersonics = 0
				
				for p in displayplayers.iterate() do
					if p.exiting > 0 or finished then
						finished = true
						continue
					else
						playercount = $+1
					end
					
					if not p.hypersonic then continue end
					if not p.hypersonic.isdead then
						pinchhypersonics = $+1
					else
						playercount = $-1
					end
				end
			end
			
			player.hypersonic.framesdead = $+1
			if player.hypersonic.timeovercam == nil then
				player.hypersonic.timeovercam = 50
			else
				player.hypersonic.timeovercam = $+1
			end
			player.kartstuff[k_timeovercam] = player.hypersonic.timeovercam
			
			if player.hypersonic.timeovercam < 50 then
				player.hypersonic.timeovercam = 50
				player.kartstuff[k_timeovercam] = 50
			end
		elseif leveltime > 6*TICRATE + (3*TICRATE/4) and player.hypersonic.usinghealth then
			if player.hypersonic.health <= 30 and player.exiting <= 0 and player.playerstate == PST_LIVE then
				local finished = false
				local hypersonics = 0
				local pinchhypersonics = 0
				
				for p in displayplayers.iterate() do
					if p.exiting > 0 or finished then
						finished = true
						continue
					end
					
					if not p.hypersonic then continue end
					hypersonics = $+1
					if p.hypersonic.health <= 30 then
						pinchhypersonics = $+1
					end
				end
			end
			
			if (leveltime - 6*TICRATE + (3*TICRATE/4)) % TICRATE == 0 then
				player.hypersonic.health = $-1
				
				if player.hypersonic.health <= 10 then
					SparkleRing(player.mo, player.hypersonic.originalcolor)
				end
			end
			if (leveltime - 6*TICRATE + (3*TICRATE/4)) % TICRATE == 18 then
				if player.hypersonic.health <= 5 then
					SparkleRing(player.mo, player.hypersonic.originalcolor)
				end
			end
			if ((leveltime - 6*TICRATE + (3*TICRATE/4)) % TICRATE) == 9 or ((leveltime - 6*TICRATE + (3*TICRATE/4)) % TICRATE) == 27 then
				if player.hypersonic.health <= 2 then
					SparkleRing(player.mo, player.hypersonic.originalcolor)
				end
			end
			
			player.hypersonic.islastplayer = false
			if player.hypersonic.health <= 0 then
				SparkleExplosion(player.mo, player.hypersonic.originalcolor)
				K_PlayLossSound(player.mo)
				player.hypersonic.isdead = true
				S_StartSoundAtVolume(mo, sfx_bkpoof, 100)
				player.mo.flags = $|MF_NOCLIP|MF_NOCLIPTHING|MF_NOCLIPHEIGHT
				
				if G_BattleGametype() then
					--Removing the player's bumpers eliminates the player automatically
					player.kartstuff[k_bumper] = 0
				else
					local totalplayers = 0
					local finishedplayers = 0
					local hypersonics = 0
					local finishedhypersonics = 0
					
					for p in players.iterate do
						totalplayers = $+1
						if p.exiting > 0 or p.lives == 0 then
							finishedplayers = $+1
						end
						if not p.hypersonic then continue end
						hypersonics = $+1
						if p.exiting > 0 or p.lives == 0 or p.hypersonic.isdead then
							finishedhypersonics = $+1
						end
					end
					
					--If we are not the last player, then the last player will exit the level, Hyper Sonic or not
					--If we "No Contest" in normal ways, then the level exit will happen normally
					if finishedplayers >= totalplayers - hypersonics and finishedhypersonics == hypersonics then
						player.hypersonic.islastplayer = true
					else
						player.hypersonic.islastplayer = false
					end
				end
			end
			
			local canhurtmore = true
			
			if player.playerstate == PST_DEAD then
				if player.hypersonic.washit < 2 then
					player.hypersonic.health = $-15
				end
				player.hypersonic.washit = 2
			end
			
			if canhurtmore and ((player.kartstuff[k_wipeoutslow] or player.kartstuff[k_spinouttimer]) and player.hypersonic.washit == 0) then
				player.hypersonic.health = $-10
				player.hypersonic.washit = 1
			end
			if not ((player.kartstuff[k_wipeoutslow] or player.kartstuff[k_spinouttimer]) or player.playerstate != PST_LIVE) and player.hypersonic.washit != 0 then
				player.hypersonic.washit = 0
			end
			
			if canhurtmore and (player.mo.eflags & MFE_JUSTBOUNCEDWALL and player.hypersonic.bounceinvuln <= 0 and not (player.kartstuff[k_invincibilitytimer] > 0 or player.kartstuff[k_growshrinktimer] > 0)) then
				player.hypersonic.health = $-5
				player.hypersonic.bounceinvuln = TICRATE
			elseif player.hypersonic.bounceinvuln > 0
				player.hypersonic.bounceinvuln = $-1
			end
		end
		
		if player.hypersonic.health then
			if player.hypersonic.health < 0 and player.hypersonic.usinghealth then
				player.hypersonic.health = 0
			end
			
			local value = 0
			if player.hypersonic.usinghealth then
				if player.hypersonic.washit then
					value = 5*FRACUNIT
				elseif player.hypersonic.bounceinvuln > 0 then
					value = 5*FRACUNIT/2
				end
			end
			HUDShake(player.mo, value)
		end
	end
end)

addHook("MobjThinker", function(mo)
	if mo.skin == "hypersonic" and mo and mo.valid and mo.health then
		--Commented out because it isn't useful
		--It tries to prevent changes from Hyper Sonic, but the server can already restrict character changes
		--Even if the server allows changes, it's super inconvenient to change it anyway,
		--so swapping from Hyper Sonic costs you a lot of lead, or even gets you hit.
		
		//if not mo.player.hypersonic then
			//if not firstgame then
				//mo.skin = "sonic"
				//CONS_Printf(mo.player, "You can't play as \130Hyper Sonic \128just yet! Switch to him during the intermission!")
			//end
			//return
		//end
		
		//if mo.player.hypersonic.canplay == nil then
			//mo.skin = "sonic"
			//CONS_Printf(mo.player, "You can't play as \130Hyper Sonic \128just yet! Switch to him during the intermission!")
			//return
		//end
		
		//if mo.player.hypersonic.canplay == 1 then
			//mo.skin = "sonic"
			//if mo.player.hypersonic.startedhyper then
				//CONS_Printf(mo.player, "It was your decision to switch from literally a god! You can switch to him during the intermission.")
			//else
				//CONS_Printf(mo.player, "You can't play as \130Hyper Sonic \128just yet! Switch to him during the intermission!")
			//end
			//return
		//end
		
		if mo.player.hypersonic == nil then
			MapLoadHook(mo.player)
		end
		mo.player.hypersonic.originalcolor = mo.player.skincolor
		if mo.player.hypersonic.isdead then
			mo.color = mo.player.hypersonic.originalcolor
			mo.flags2 = $|MF2_DONTDRAW
			
			if not mo.player.hypersonic.sonicdummy then
				mo.player.hypersonic.sonicdummy = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SONICDUMMY)
				mo.player.hypersonic.sonicdummy.source = mo.player
				mo.player.hypersonic.sonicdummy.color = mo.color
				mo.player.hypersonic.sonicdummy.sprite = SPR_DEDS
				mo.player.hypersonic.sonicdummy.angle = mo.angle
				mo.player.hypersonic.sonicdummy.radius = mo.radius
				mo.player.hypersonic.sonicdummy.height = mo.height
				mo.player.hypersonic.sonicdummy.animatetimer = 14
				if P_IsObjectOnGround(mo) then
					mo.player.hypersonic.sonicdummy.frame = B
				else
					mo.player.hypersonic.sonicdummy.frame = A
				end
			else
				
			end
			
			if P_IsObjectOnGround(mo) then
				P_InstaThrust(mo, 0, 0)
			end
			
			P_SetOrigin(mo.player.hypersonic.sonicdummy, mo.x, mo.y, mo.z)
			
			return
		end
		
		if not mo.player.hypersonic then
			mo.player.hypersonic = {}
			mo.player.hypersonic.lastboosttimer = 0
			mo.player.hypersonic.timesincelastring = 35
			mo.player.hypersonic.runthinker = true
			return
		end
		
		//if mo.player.hypersonic.loadedfile == nil then
			//local file = io.open("hypersonic.cfg", "r")
			
			//if not file or file == nil then
				//file = io.open("hypersonic.cfg", "w")
				//file:write([[0]])
				//file:close()
			//else
				//file:close()
			//end
			
			//local file3 = io.open("hypersonic.cfg", "r")
			//if file3:read("*n") == 0 then
				//mo.player.hypersonic.hyperflashing = false
				//mo.player.hypersonic.returncolor = true
			//else
				//mo.player.hypersonic.hyperflashing = true
				//mo.player.hypersonic.returncolor = false
			//end
			//mo.player.hypersonic.returncoloroverride = false
			//file3:close()
			//mo.player.hypersonic.loadedfile = true
		//end
		local value = FRACUNIT*2
		
		if P_IsObjectOnGround(mo) then
			--What, it's an air dash for a reason
			mo.player.hypersonic.airdashusable = false
			mo.player.hypersonic.airdashusable2 = false
			mo.player.hypersonic.airdashused = false
		else
			mo.player.hypersonic.airdashusable = (mo.player.cmd.buttons & BT_BRAKE == 8) and (mo.player.cmd.buttons & BT_DRIFT == 4)
			if not mo.player.hypersonic.airdashusable then
				mo.player.hypersonic.airdashusable2 = true
			end
		end
		
		local nuked = false
		
		--Spinout and Wipeout are completely different, one just wipes out your speed entirely
		if mo.player.hypersonic.airdashusable and mo.player.hypersonic.airdashusable2 and not mo.player.hypersonic.airdashused and mo.player.kartstuff[k_spinouttimer] == 0 and mo.player.kartstuff[k_wipeoutslow] == 0 then
			P_InstaThrust(mo, mo.player.cmd.angleturn*FRACUNIT, max(mo.player.speed, 64*FRACUNIT))
			P_SetObjectMomZ(mo, 0)
			mo.player.hypersonic.airdashused = true
			//P_NukeEnemies(mo, mo, 512*FRACUNIT)
			K_DoSneaker(mo.player, 0)
			--To at least somewhat prevent your ears from being nuked
			S_StartSoundAtVolume(mo, sfx_bkpoof, 100)
			nuked = true
		end
		
		mo.player.hypersonic.timesincelastring = $+1
		
		--The reason you're probably here: speed
		mo.player.kartstuff[k_offroad] = 0
		if mo.player.kartstuff[k_invincibilitytimer] > 0 then
			value = $*3/2
		end
		if mo.player.kartstuff[k_growshrinktimer] > 0 then
			value = $*3/2
		end
		if mo.player.kartstuff[k_growshrinktimer] < 0 then
			value = $/3*2
		end
		if mo.player.kartstuff[k_sneakertimer] > 0 then
			value = $*3/2
			if mo.player.hypersonic.lastboosttimer <= mo.player.kartstuff[k_sneakertimer] then
				if mo.player.hypersonic.timesincelastring >= 10 then
					SparkleRing(mo, mo.player.hypersonic.originalcolor)
					mo.player.hypersonic.timesincelastring = 0
				end
				
				--It's cross-mod support with Acrobatics
				--All it does is give you health based on your trick
				if mo.player.trickgrade == nil or mo.player.trickgrade <= 0 then
					--So pure speed sections aren't as generous
					if mo.player.hypersonic.lastboosttimer == 0 and not nuked then
						mo.player.hypersonic.health = $+10
					end
				else
					--These numbers are so high because the trick boost is likely to send you into a pit
					if mo.player.trickgrade == 1 then
						mo.player.hypersonic.health = $+5
					elseif mo.player.trickgrade == 2 then
						mo.player.hypersonic.health = $+10
					elseif mo.player.trickgrade == 3 then
						mo.player.hypersonic.health = $+15
					elseif mo.player.trickgrade == 4 then
						mo.player.hypersonic.health = $+20
					elseif mo.player.trickgrade == 5 then
						mo.player.hypersonic.health = $+30
					end
				end
			end
		end
		
		mo.player.kartstuff[k_boostpower] = value
		if mo.eflags & MFE_SPRUNG then
			mo.player.kartstuff[k_accelboost] = 0
		else
			mo.player.kartstuff[k_accelboost] = value
		end
		
		if mo.player.kartstuff[k_driftboost] > 0 and not mo.player.hypersonic.driftboosting and mo.player.hypersonic.usinghealth and not mo.player.hypersonic.isdead then
			if mo.player.hypersonic.lastdriftboost >= K_GetKartDriftSparkValue(mo.player)*4 then
				mo.player.hypersonic.health = $+15
			elseif mo.player.hypersonic.lastdriftboost >= K_GetKartDriftSparkValue(mo.player)*2 then
				mo.player.hypersonic.health = $+10
			elseif mo.player.hypersonic.lastdriftboost >= K_GetKartDriftSparkValue(mo.player) then
				mo.player.hypersonic.health = $+5
			end
			mo.player.hypersonic.driftboosting = true
		end
		
		if mo.player.kartstuff[k_driftboost] == 0 then
			mo.player.hypersonic.driftboosting = false
		end
		
		mo.player.hypersonic.lastboosttimer = mo.player.kartstuff[k_sneakertimer]
		mo.player.hypersonic.lastdriftboost = mo.player.kartstuff[k_driftcharge]
		mo.player.hypersonic.lastdrifttimer = mo.player.kartstuff[k_driftboost]
		
		P_SpawnGhostMobj(mo)
		
		Sparkle(mo, P_RandomRange(-9, 9) * FRACUNIT, P_RandomRange(-9, 9) * FRACUNIT, P_RandomRange(-9, 9) * FRACUNIT, true, nil, mo.player.hypersonic.originalcolor)
		
		if mo.player.hypersonic.health <= 30 and mo.player.hypersonic.usinghealth and leveltime > 3*TICRATE then
			Sparkle(mo, P_RandomRange(-9, 9) * FRACUNIT, P_RandomRange(-9, 9) * FRACUNIT, P_RandomRange(-9, 9) * FRACUNIT, true, nil, mo.player.hypersonic.originalcolor)
			if not mo.player.hypersonic.waslow then
				local sound = P_RandomRange(1, 3)
				if sound == 1 then
					sound = sfx_hyprw1
				elseif sound == 2 then
					sound = sfx_hyprw2
				else
					sound = sfx_hyprw3
				end
				S_StartSound(mo, sound, mo.player)
				mo.player.hypersonic.waslow = true
			end
		else
			mo.player.hypersonic.waslow = false
		end
		
		--Disabled so you can easily tell who is who
		if false and not mo.player.hypersonic.hyperflashing and not mo.player.hypersonic.returncoloroverride and not mo.player.hypersonic.isdead then
			if mo.color == SKINCOLOR_SALMON then
				mo.color = SKINCOLOR_LEMONADE
			elseif mo.color == SKINCOLOR_LEMONADE then
				mo.color = SKINCOLOR_CREAMSICLE
			elseif mo.color == SKINCOLOR_CREAMSICLE then
				mo.color = SKINCOLOR_CREAM
			elseif mo.color == SKINCOLOR_CREAM then
				mo.color = SKINCOLOR_CROCODILE
			elseif mo.color == SKINCOLOR_CROCODILE then
				mo.color = SKINCOLOR_LIME
			elseif mo.color == SKINCOLOR_LIME then
				mo.color = SKINCOLOR_DREAM
			elseif mo.color == SKINCOLOR_DREAM then
				mo.color = SKINCOLOR_CYAN
			elseif mo.color == SKINCOLOR_CYAN then
				mo.color = SKINCOLOR_LILAC
			elseif mo.color == SKINCOLOR_LILAC then
				mo.color = SKINCOLOR_SALMON
			else
				mo.color = SKINCOLOR_SALMON
			end
		elseif mo.player.hypersonic.returncolor or mo.player.hypersonic.returncoloroverride then
			mo.color = mo.player.hypersonic.originalcolor
			mo.player.hypersonic.returncolor = false
			mo.player.hypersonic.returncoloroverride = false
		end
	elseif mo and mo.valid then
		--Commented out for the same reasons as above
		
		//if mo.player.playerstate != PST_LIVE then return end
		
		//if mo.player.hypersonic then
			//if mo.player.hypersonic.startedhyper then
				--There is no health system
				//if CV_FindVar("hyper_health").value == 0 then
					//CONS_Printf(mo.player, "It's not cheating to switch from Hyper Sonic without the health system, but you're not switching back until the end of the match!")
					//mo.player.hypersonic.startedhyper = false
					//mo.player.hypersonic.canplay = 1
				//elseif mo.skin != "hypersonic"
					//mo.skin = "hypersonic"
					//CONS_Printf(mo.player, "You can't switch from Hyper Sonic in the middle of a match! Switch to him during the intermission!")
				//end
			//end
		//else
			//mo.player.hypersonic = {}
			//mo.player.hypersonic.startedhyper = false
			//mo.player.hypersonic.canplay = 1
		//end
	end
end, MT_PLAYER)

addHook("MobjThinker", function(mo)
	if not mo.source return end
    mo.life = $ or 0
	if mo.source.valid then
		if mo.offset then
			P_SetOrigin(mo, mo.source.x + mo.life * mo.momx, mo.source.y + mo.life * mo.momy, mo.source.z + 17*FRACUNIT + mo.life * mo.momz)
		else
			P_SetOrigin(mo, mo.source.x + mo.life * mo.momx, mo.source.y + mo.life * mo.momy, mo.source.z + mo.life * mo.momz)
		end
	else
		P_SetOrigin(mo, mo.x + mo.momx, mo.y + mo.momy, mo.z + mo.momz)
	end
	
    mo.life = $ + 1
	if mo.sprite != SPR_SPKL then
		mo.sprite = SPR_SPKL
		local framenum = P_RandomRange(1, 3)
		if framenum == 1 then
			mo.frame = A
		elseif framenum == 2 then
			mo.frame = B
		else
			mo.frame = C
		end
	end
	
	if mo.explosion then
		if mo.life % 3 == 0 then
			if mo.frame == A then
				mo.frame = B
			elseif mo.frame == B then
				mo.frame = C
			elseif mo.frame == C then
				mo.frame = A
			end
		end
	elseif mo.animation then
		if mo.frame == A and mo.life == 3 then
			mo.frame = B
		elseif mo.frame == B and mo.life == 6 then
			mo.frame = C
		end
	end
end, MT_HYPERSONICSPARKLE)

addHook("MobjThinker", function(mo)
	mo.sprite = SPR_DEDS
	if P_IsObjectOnGround(mo) then
		if mo.frame == A then
			mo.frame = B
		end
		if mo.animatetimer <= 0 then
			if mo.frame == B then
				mo.frame = C
			elseif mo.frame == C
				mo.frame = B
			end
			mo.animatetimer = 14
		end
		
		mo.animatetimer = $-1
	else
		mo.frame = A
	end
	mo.color = mo.source.skincolor
end, MT_SONICDUMMY)

addHook("PlayerSpin", function(target, inflictor, source)
	--No, you're not getting HP by hitting yourself
	if source == target.mo then return end
	if not source then return end
	if not source.valid then return end
	if not source.player then return end
	if not source.player.hypersonic then return end
	if not (source.skin == "hypersonic") then return end
	
	--No, you're not reviving because of that dang orbinaut that didn't despawn
	if not source.player.hypersonic.isdead and source.player.hypersonic.usinghealth then
		source.player.hypersonic.health = $+20
	end
end)

addHook("PlayerExplode", function(target, inflictor, source)
	--No, you're not getting HP by hitting yourself
	if source == target.mo then return end
	if not source then return end
	if not source.valid then return end
	if not source.player then return end
	if not source.player.hypersonic then return end
	if not (source.skin == "hypersonic") then return end
	
	--No, you're not reviving because of that dang orbinaut that didn't despawn
	if not source.player.hypersonic.isdead and source.player.hypersonic.usinghealth then
		source.player.hypersonic.health = $+20
	end
end)

addHook("PlayerSquish", function(target, inflictor, source)
	--No, you're not getting HP by hitting yourself
	if source == target.mo then return end
	if not source then return end
	if not source.valid then return end
	if not source.player then return end
	if not source.player.hypersonic then return end
	if not (source.skin == "hypersonic") then return end
	
	--No, you're not reviving because of that dang orbinaut that didn't despawn
	if not source.player.hypersonic.isdead and source.player.hypersonic.usinghealth then
		source.player.hypersonic.health = $+20
	end
end)